#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

class SidfmdLversion < ActiveRecord::Base
  scope :support_end_versions, -> { where("eol_date < ?", Date.today) }
  scope :fullname_matched, -> (keyword) {
    where(
      'LOWER(fullname) LIKE ? OR LOWER(fullname) LIKE ?',
      ActiveRecord::Base.send(:sanitize_sql_like, keyword.downcase) + '%',
      '% ' + ActiveRecord::Base.send(:sanitize_sql_like, keyword.downcase) + '%'
    )
  }

  belongs_to :sidfmd_lproduct
  has_many :sidfmd_rule_cm_lapp_subs, dependent: :delete_all

  def is_support_end
    eol_date ? Date.today > eol_date : false
  end

end
