;

var SidColors;
var SidCvss2Map;
var SidCvss3Map;
$(function(){
  var cmap = {cvss:{}, risk:{}};
  [0,1,2,3,4,5,6,7,8,9,10,"ur"].forEach(function(sc){
    var j_cvss = $("<div>").addClass("bgc_cvss" + sc).hide();
    $(document.body).append(j_cvss);
    cmap["cvss" + sc] = j_cvss.css("background-color");
    cmap.cvss[sc] = j_cvss.css("background-color");
    if(sc === "ur"){
      cmap.cvss[-1] = j_cvss.css("background-color");
    }
    j_cvss.remove();
  });
  [0,1,2,3,4].forEach(function(r){
    var j_risk = $("<div>").addClass("bgc_risk_d" + r).hide();
    $(document.body).append(j_risk);
    cmap[r] = j_risk.css("background-color");
    cmap.risk[r] = j_risk.css("background-color");
    j_risk.remove();
  });
  SidColors = cmap;

  // cvss.vector の文字列をもとにして、cvss.base_av などのプロパティを設定する
  var parse_vector_string = function(cvss){ // cvss.vector が必要
    var _this = this;
    Object.keys(_this).forEach(function(key){
      var metric = _this[key];
      var metric_value = "X"
      if(typeof metric === "object" && metric.abbr){
        if(cvss.vector != null){
          metric_value = cvss.vector.charAt(metric.pos);
        }
        cvss["base_" + metric.abbr.toLowerCase()] = metric_value.toLowerCase();
        cvss[metric.abbr.toLowerCase()] = metric_value.toLowerCase();
      }
    });
    return cvss;
  };


  var cvss2_map = {
    av:{X:4, N:3, A:2, L:1, pos:3, abbr:"AV",
      value_name:{4:"未評価", 3:"ネットワーク", 2:"隣接ネットワーク", 1:"ローカル"},
      colors:{4:cmap.cvssur,3:cmap.cvss9, 2:cmap.cvss6, 1:cmap.cvss3}
    },
    ac:{X:4, L:3, M:2, H:1, pos:8, abbr:"AC",
      value_name:{4:"未評価", 3:"簡単", 2:"やや難しい", 1:"難しい"},
      colors:{4:cmap.cvssur,3:cmap.cvss9, 2:cmap.cvss6, 1:cmap.cvss3}
    },
    au:{X:4, N:3, S:2, M:1, pos:13, abbr:"Au",
      value_name:{4:"未評価", 3:"不要", 2:"単一", 1:"複数"},
      colors:{4:cmap.cvssur,3:cmap.cvss9, 2:cmap.cvss6, 1:cmap.cvss3}
    },
    c: {X:4, C:3, P:2, N:1, pos:17, abbr:"C",
      value_name:{4:"未評価", 3:"全面的", 2:"部分的", 1:"影響無し"},
      colors:{4:cmap.cvssur,3:cmap.cvss9, 2:cmap.cvss6, 1:cmap.cvss0}
    },
    i: {X:4, C:3, P:2, N:1, pos:21, abbr:"I",
      value_name:{4:"未評価", 3:"全面的", 2:"部分的", 1:"影響無し"},
      colors:{4:cmap.cvssur,3:cmap.cvss9, 2:cmap.cvss6, 1:cmap.cvss0}
    },
    a: {X:4, C:3, P:2, N:1, pos:25, abbr:"A",
      value_name:{4:"未評価", 3:"全面的", 2:"部分的", 1:"影響無し"},
      colors:{4:cmap.cvssur,3:cmap.cvss9, 2:cmap.cvss6, 1:cmap.cvss0}
    },
    parse_vector_string: parse_vector_string,
    metric_value_name: function(cvss, metric){
      var _this = this;
      var metric_attr = _this[metric];
      var value = cvss[metric];
      var v = metric_attr[value.toUpperCase()];
      return metric_attr.value_name[v];
    }
  };
  SidCvss2Map = cvss2_map;

  var cvss3_map = {
    av:{X:5, N:4, A:3, L:2, P:1, pos:3, name:"攻撃元区分", abbr:"AV",
      value_name:{5:"未評価", 4:"ネットワーク", 3:"隣接", 2:"ローカル", 1:"物理"},
      colors: {5:cmap.cvssur, 4:cmap.cvss9, 3:cmap.cvss6, 2:cmap.cvss3, 1:cmap.cvss1}
    },
    ac:{X:5, L:4, H:2, pos:8, name:"攻撃条件の複雑さ", abbr:"AC",
      value_name:{5:"未評価", 4:"低", 2:"高"},
      colors: {5:cmap.cvssur, 4:cmap.cvss9, 2:cmap.cvss3}
    },
    pr:{X:5, N:4, L:3, H:2, pos:13, name:"必要な特権レベル", abbr:"PR",
      value_name:{5:"未評価", 4:"不要", 3:"低", 2:"高"},
      colors: {5: cmap.cvssur, 4:cmap.cvss9, 3:cmap.cvss6, 2:cmap.cvss3}
    },
    ui:{X:5, N:4, R:3, pos:18, name:"ユーザ関与レベル", abbr:"UI",
      value_name:{5:"未評価", 4:"不要", 3:"要"},
      colors: {5:cmap.cvssur, 4:cmap.cvss9, 3:cmap.cvss6}
    },
    s:{X:5, C:4, U:3, pos:22, name:"スコープ", abbr:"S",
      value_name:{5:"未評価", 4:"変更あり", 3:"変更なし"},
      colors: {5:cmap.cvssur, 4:cmap.cvss9, 3:cmap.cvss6}
    },
    c: {X:5, H:4, L:3, N:1, pos:26, name:"機密性への影響", abbr:"C",
      value_name:{5:"未評価", 4:"高", 3:"低", 1:"なし"},
      colors: {5:cmap.cvssur, 4:cmap.cvss9, 3:cmap.cvss6, 1:cmap.cvss1}
    },
    i: {X:5, H:4, L:3, N:1, pos:30, name:"完全性への影響", abbr:"I",
      value_name:{5:"未評価", 4:"高", 3:"低", 1:"なし"},
      colors: {5:cmap.cvssur, 4:cmap.cvss9, 3:cmap.cvss6, 1:cmap.cvss1}
    },
    a: {X:5, H:4, L:3, N:1, pos:34, name:"可用性への影響", abbr:"A",
      value_name:{5:"未評価", 4:"高", 3:"低", 1:"なし"},
      colors: {5:cmap.cvssur, 4:cmap.cvss9, 3:cmap.cvss6, 1:cmap.cvss1}
    },
    parse_vector_string:parse_vector_string,
    metric_value_name: function(cvss, metric){
      var _this = this;
      var metric_attr = _this[metric];
      var value = cvss[metric];
      var v;
      if(value === undefined && cvss.ver === 2){
        if(metric === "pr"){
          metric = "ac";
          value = cvss[metric];
        }else{
          value = "x";
        }
      }
      if(metric_attr !== undefined){
        v = metric_attr[value.toUpperCase()];
      }
      if(v === undefined){
        switch(metric){
          case "ac":
            switch(value){
              case "m": value = "l"; break;
            }
            break;
          case "au":
            switch(value){
              case "n": value = "n"; break;
              case "s": value = "l"; break;
              case "m": value = "h"; break;
            }
            break;
          case "c":
          case "i":
          case "a":
            switch(value){
              case "p": value = "l"; break;
              case "c": value = "h"; break;
            }
        }
        v = metric_attr[value.toUpperCase()];
      }
      return metric_attr.value_name[v];
    }
  };
  SidCvss3Map = cvss3_map;
});

var CvssRadar = function(selector, cvss, opts){this.init(selector, cvss, opts)};
CvssRadar.prototype = {
  init:function(selector, cvss, opts){
    var _this = this;
    _this.selector = selector;
    _this.cvss = cvss;
    var re_cvss2 = /^AV:[A-Z]\/AC:[A-Z]\/AU:[A-Z]\/C:[A-Z]\/I:[A-Z]\/A:[A-Z]/i;
    if(_this.cvss.vector == null){
      _this.cvss_ver = null;
      _this.cvss_map = SidCvss3Map;
      _this.cvss = _this.cvss_map.parse_vector_string(_this.cvss);
    }else if(re_cvss2.test(_this.cvss.vector)){
      _this.cvss.ver = 2;
      _this.cvss_map = SidCvss2Map;
      _this.cvss = _this.cvss_map.parse_vector_string(_this.cvss);
    }else{
      _this.cvss.ver = 3;
      _this.cvss_map = SidCvss3Map;
      _this.cvss = _this.cvss_map.parse_vector_string(_this.cvss);
    }
    _this.color_map = SidColors;
    _this.opts = opts || {};
  },
  render:function(){
    var _this = this;
    var d = [];
    var key_order;
    var copts = {};
    if(_this.cvss.ver === 2){
      key_order = ["av", "ac", "au", "c", "i", "a"];
      copts = $.extend(copts, {maxValue:3, centerStart:false, levels:3});
    }else{
      key_order = ["pr", "ui", "s", "c", "i", "a", "av", "ac"];
      copts = $.extend(copts, {maxValue:4, centerStart:true, levels:1});
    }
    key_order.forEach(function(key){
      var metric = _this.cvss_map[key]
      var metric_value = _this.cvss["base_" + key];
      var v = metric[metric_value.toUpperCase()];
      d.push({axis:metric.abbr, value:v, text:metric.value_name[v], color:metric.colors[v]});
    });
    if(_this.cvss.vector != null){
      var color = _this.color_map["cvss" + Math.floor(_this.cvss.base_score)];
    }else{
      var color = _this.color_map["cvssur"];
    }
    switch(_this.opts.type){
      case "max":
        copts = $.extend(copts, {
          w:120, h:120, radius:5, factor:.7, factorLegend:1.0,
          color:d3.scaleOrdinal().range([color]), fontSize:12, fontBold:true,
        });
        var css;
        break;
      case "vuln_content":
        copts = $.extend(copts, {
          w:60, h:60, radius:3, factor:.6, factorLegend:1.0,
          color:d3.scaleOrdinal().range([color]), fontSize:10, fontBold:true,
        });
        var css;
        break;
      case "vuln_content_ref":
        copts = $.extend(copts, {
          w:18, h:18, radius:0, factor:.95, legend:false,
          color:d3.scaleOrdinal().range([color]), 
        });
        var css = "vertical-align:middle;";
        break;
      default:
        var copts = $.extend(copts, {
          w:80, h:80, radius:3, factor:.7, factorLegend:.9,
          color:d3.scaleOrdinal().range([color]), fontSize:14, fontBold:true, maxValue:3,
        });
        var css = "vertical-align:middle;";
    }
    RadarChart.draw(_this.selector, [d], copts);
    $(_this.selector).find("svg").attr("style", css);

    return _this;
  }
};

var SidContentFormatter = (function(){
  var SidContentFormatter = function(vuln){
    this.vuln = vuln;
  };

  SidContentFormatter.prototype = {
    render_cvss_radars:function(){
      var _this = this;
      var vuln = _this.vuln;
      vuln.cves.forEach(function(cve, idx){
        var cvss;
        if(cve.cvss3 && cve.cvss3.vector != null){
          cvss = cve.cvss3;
        }else if(cve.cvss2 && cve.cvss2.vector != null){
          cvss = cve.cvss2;
        }
        if(cvss != null){
          if($(".j_cve_cvss_radar." + cve.cve_id).length > 0){
            //var c = new CvssRadar(".j_cve_cvss_radar." + cve.cve_id, cvss, {type:"vuln_content"});
            if($("ol > li.d1 .j_cve_cvss_radar." + cve.cve_id).length > 0){
              var c = new CvssRadar("ol > li.d1 .j_cve_cvss_radar." + cve.cve_id, cvss, {type:"vuln_content"});
              c.render();
            }
            if($("ul > li.d1 .j_cve_cvss_radar." + cve.cve_id).length > 0){
              var c = new CvssRadar("ul > li.d1 .j_cve_cvss_radar." + cve.cve_id, cvss, {type:"vuln_content_ref"});
              c.render();
            }
          }
        }
      });
      return;
    },
    embed_cvss_elms:function(phtml){ // use
      var _this = this;
      var vuln = _this.vuln;
      var jphtml = $("<div>").append(phtml);

      var jbranches = jphtml.find("li.d1");
      jbranches.each(function(i, elm){
        var jbranch = $(elm);
        jbranch.wrapInner("<div class=\"_branch_description\"></div>")
        jbranch.wrapInner("<div class=\"_branch j_branch\"></div>")
      });

      var cves = _this.vuln.cves.slice();
      cves = cves.sort(function(cve1, cve2){
        if(cve1.cve_cvss != null && cve2.cve_cvss != null){
          if(cve1.cve_cvss.base_score > cve2.cve_cvss.base_score){
            return -1;
          }else if(cve2.cve_cvss.base_score > cve1.cve_cvss.base_score){
            return 1;
          }else{
            return 0;
          }
        }else if(cve1.cve_cvss != null){
          return -1;
        }else if(cve2.cve_cvss != null){
          return 1;
        }
        return 0;
      });

      cves.forEach(function(cve){
        var cvss = cve.cve_cvss;
        if(cvss.base_score > -1){
          var jscore = $("<div>");
          jscore
            .addClass("j_cve_cvss_score").addClass("_cve_cvss_score").addClass(cve.cve_id)
            .text(cvss.base_score.toFixed(1))
            .addClass("c_cvss" + cvss.base_score.toFixed(0))
          ;
          var jexploit;
          if(cvss.exploitable === true){
            jexploit = $("<div>").addClass("_cve_exploitable");
            jexploit.append(
              $("<i>")
                .addClass("fas").addClass("fa-bomb").addClass("_vuln_exploit_icon")
                .attr("title", "既に攻撃コードもしくは実証コードが確認されています")
            );
          }
          var jradar = $("<div>").addClass("j_cve_cvss_radar").addClass(cve.cve_id).addClass("_cve_cvss_radar");
          var jcvss = $("<div>").addClass("_cve_cvss")
            .append(jradar, jscore, jexploit)
          ;
          var j_cve_branches = jphtml.find("a:contains(" + cve.cve_id + ")").closest(".j_branch");
          j_cve_branches.each(function(i, elm){
            var jbranch = $(elm);
            if(jbranch.find(".j_cve_cvss_radar").length === 0){
              jbranch.prepend(jcvss);
            }
          });
        }

        var j_cve_subtitle = jphtml.find("a:contains(" + cve.cve_id + ")").closest("p.subtitle");
        var janchor = $("<a>").attr("id",cve.cve_id);
        $(j_cve_subtitle[0]).prepend(janchor);
      });
      jphtml.find(".j_branch").prepend($("<div>").addClass("_dummy").append("&nbsp;"));
      return jphtml.html();
    }
  };

  return SidContentFormatter;
})();
