#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

require 'digest/sha2'

module SofTekUtils

  # ランダムに生成した文字列に、前後(pre, post)に指定した文字列を
  # 連結した文字列に対して、SHA2のhexdigestを生成して返す。
  # 主にAPIKEY用に利用することを想定。
  def self.hexdigest(pre: '', post: '')
    Digest::SHA2.hexdigest(pre + (512.times.inject('') {|r, x| r << rand(256).chr}) + post)
  end

end
